%% Proximity, input
clear all;
I = rgb2gray(imread('Input\lizard2.jpg'));
% [e, dir] = prewitt(I,50);
e = edge(I,'prewitt');
% figure;
% imshow(e);
% title('edge map');
ue =  rgb2gray(imread('Input\lizard ue1.jpg'));
% ue =  rgb2gray(imread('Input\lizard ue2.jpg'));
% ue =  rgb2gray(imread('Input\lizard ue3.jpg'));
ue = ue < 100;

zeroFrame(ue);
zeroFrame(e);


%% Proximity, processing and output
r = 3; % elipse radius, 3% of the picture size.
f = 40; % focal distance, 40% of r.
rr = ceil((r/100) * min(size(I)));
ff = (f / 100) .* rr;
tic
fe = proximityFilter(rr,ff,e,ue);
time = toc;

figure, imshow(fe);
title(sprintf('R = %d, F = %d, time = %0.2fsec',r,f,time));





%% Intersection, input

clear all;
window_offset = 1;% window_offset of 1. -> window 3x3.
                % change to higher number, like 3, for discontinuous edges.
I = rgb2gray(imread('Input\lizard2.jpg'));
[e, dir] = prewitt(I,50);
% e = edge(I,'prewitt');

ul =  rgb2gray(imread('Input\lizard ul1.jpg'));
% ul =  rgb2gray(imread('Input\lizard ul2.jpg'));
% ul =  rgb2gray(imread('Input\lizard ul3.jpg'));
ul = (ul < 100) & e;

ul = zeroFrame(ul, window_offset);
e  = zeroFrame(e,   window_offset);


%% Line crossing showing results

tic
um = intersectionFilter(ul, e, window_offset);
time = toc;

figure, imshow(um);
title(sprintf('Window size %d, time = %0.2fsec',window_offset, time));

%%

