function [ um ] = intersectionFilter( ul, e, window_offset )
% INTERSECTIONFILTER Intersection based edge detector
%   Filter edge map "e" based on the user input "ul".
%   e - edge map.
%   ul - user input.
%   window_offset - size of the window used by the hysteresis.

    [ulx, uly] = find(ul);
    qx = Queue;
    qy = Queue;
    for index = 1: size(ulx,1);
        qx.add(ulx(index));
        qy.add(uly(index));

    end

    um = zeros(size(ul));
    
    while ~qx.isEmpty && ~qy.isEmpty 
        x = qx.remove;
        y = qy.remove;
        if (um(x,y) == 0)
            um(x,y) = 1;
            window = e(x-window_offset:x+window_offset,y-window_offset:y+window_offset);
            [wx, wy]= find(window);
            wx = wx + x - 1;
            wy = wy + y - 1;

            for index = 1:size(wx,1);
               u = wx(index);
               v = wy(index);
                if um(u,v) == 0
                    qx.add(u);
                    qy.add(v);
                end
            end
        end;
    end

end

