function [ TEdge, Dir ] = prewitt( I, threshold )
%PERWITT applys prewitt and returns edge points and thier direction.
%   I - Image.
%   threshold - the thrashold used by prewitt's algorithm.
%   Tedge - edge map after the trashold was applied.
%   Dir - the direction of evrey edge.

    prewittx = [1, 0, -1; 1, 0, -1; 1, 0, -1];
    prewitty = [1, 1, 1; 0, 0, 0; -1, -1, -1];
    Ix = conv2(double(I), prewittx, 'same');
    Iy = conv2(double(I), prewitty, 'same');
    Dir = atan2(Iy,Ix) + pi/2;
    Ix = Ix.^2;
    Iy = Iy.^2;
    Edge = sqrt(Ix+Iy);
    Dir(Edge == 0) = NaN;
    TEdge = (Edge > threshold);
%     Edge = uint8(Edge);
end

