function [ m ] = zeroFrame( m, offset )
%ZEROFRAME surrounds matrix m with zero padding of the size offset.
%   m - input matrix
%   offset - how many rows / columns sould be padded with zeroes.
    if (nargin <= 1 || offset < 1 || offset > min(size(m)))
        offset = 1;
    end;
    m(1:offset,:) = 0;
    m(:,1:offset) = 0;
    offset = offset - 1;
    m(size(m,1)-offset:size(m,1),:) = 0;
    m(:,size(m,2)-offset:size(m,2)) = 0;

end

